context("methods for generics from vctrs (i.e., tidyverse support)")

test_that(
  "methods for vec_ptype2() and vec_cast()"
  , {
    library(vctrs)
    obj1 <- obj2 <- obj3 <- 1:4
    variable_label(obj1) <- "a"
    variable_label(obj2) <- "b"

    combined_prototype <- integer(0L)
    variable_label(combined_prototype) <- c("a")

    labelled_integer <- integer(0L)
    labelled_double  <- double(0L)
    labelled_complex <- complex(0L)
    variable_label(labelled_integer) <- "a"
    variable_label(labelled_double)  <- "a"
    variable_label(labelled_complex) <- "a"

    # Both labelled:
    expect_warning(
      expect_identical(vec_ptype2(obj1, obj2), combined_prototype) # "a"
      , regexp = "While combining two labelled vectors, variable label 'b' was dropped and variable label 'a' was retained."
    )
    expect_identical(vec_ptype2(obj1, obj1), labelled_integer)   # "a"

    expect_identical(vec_ptype2(obj1, TRUE), labelled_integer)
    expect_identical(vec_ptype2(TRUE, obj1), labelled_integer)
    expect_identical(vec_ptype2(obj1, 1L), labelled_integer)
    expect_identical(vec_ptype2(obj1, 1.4), labelled_double)
    expect_identical(vec_ptype2(obj1, complex(1)), labelled_complex)

    expect_identical(vec_ptype2(logical(1), obj1), labelled_integer)
    expect_identical(vec_ptype2(integer(1), obj1), labelled_integer)
    expect_identical(vec_ptype2(double(1) , obj1), labelled_double)
    expect_identical(vec_ptype2(complex(1), obj1), labelled_complex)

    # logical to labelled
    expect_identical(
      vec_cast(x = TRUE, vec_ptype2(obj1, TRUE))
      , obj1[1]
    )
    # labelled to same labelled
    expect_identical(
      vec_cast(x = obj1, obj1[FALSE])
      , obj1
    )

    # labelled to other labelled
    expect_warning(
      expect_identical(
        vec_cast(x = obj1, vec_ptype2(obj2, obj1))
        , obj2
      )
      , regexp = "While combining two labelled vectors, variable label 'a' was dropped and variable label 'b' was retained."
    )

    # labelled to logical
    expect_identical(
      vec_cast(obj1, double(0L))
      , as.double(1:4)
    )
  }
)

test_that(
  "vctrs in action"
  , {

    variable_label(npk) <- c(N = "Nitrogen")
    expected <- rep(npk$N, 3L)

    expect_identical(
      vctrs::vec_rep(npk$N, 3L)
      , expected
    )
  }
)

context("onload")

test_that(
  "Register S3 methods if vctrs package available"
  , {
    tinylabels:::.onLoad()
    library(vctrs)
    vec_ptype2_methods <- as.character(methods("vec_ptype2"))
    vec_cast_methods   <- as.character(methods("vec_cast"))

    expected_support <- c(
      "tiny_labelled" # self-self
      , "logical"
      , "integer"
      , "double"
      , "complex"
      , "raw"
      , "character"
      , "factor"
      , "ordered"
    )

    expect(
      all(
        paste0("vec_ptype2.tiny_labelled.", expected_support) %in% vec_ptype2_methods
      )
      , failure_message = "Not all vec_ptype2()-methods available."
    )
    expect(
      all(
        paste0("vec_ptype2.", expected_support, ".tiny_labelled") %in% vec_ptype2_methods
      )
      , failure_message = "Not all vec_ptype2()-methods available."
    )
    expect(
      all(
        paste0("vec_cast.tiny_labelled.", expected_support) %in% vec_cast_methods
      )
      , failure_message = "Not all vec_cast()-methods available."
    )
    expect(
      all(
        paste0("vec_cast.", expected_support, ".tiny_labelled") %in% vec_cast_methods
      )
      , failure_message = "Not all vec_cast()-methods available."
    )
  }
)

test_that(
  "as()"
  , {
    test <- 1:4
    variable_label(test) <- "a"

    expect_identical(
      as(test, "logical")
      , as(1:4, "logical")
    )

    expect_identical(
      as(test, "integer")
      , as(1:4, "integer")
    )
    expect_identical(
      as(test, "numeric")
      , as(1:4, "numeric")
    )
    expect_identical(
      as(test, "double")
      , as(1:4, "double")
    )
    expect_identical(
      as(test, "character")
      , as(1:4, "character")
    )


  }
)

context(context("methods for generics from base"))

test_that(
  "droplevels.tiny_labelled-method"
  , {
    # only check consistency, as base behavior has changed recently
    x <- factor(letters[1:4], levels = letters[1:10])
    variable_label(x) <- "Test me!"
    x <- droplevels(x, exclude = "d")

    y <- factor(letters[1:4], levels = letters[1:10])
    y <- droplevels(y, exclude = "d")
    variable_label(y) <- "Test me!"

    expect_identical(
      object = x
      , expected = y
    )
  }
)

test_that(
  "[.tiny_labelled-method, [[.tiny_labelled-method"
  , {
    x <- factor(letters[1:4], levels = letters[1:10])
    variable_label(x) <- "Test me!"
    y <- x[1:3]
    z <- x[[2, keep_label = TRUE]]
    zz <- x[[2]]

    expect_identical(
      object = y
      , expected = structure(
        1:3
        , .Label = letters[1:10]
        , class = c("tiny_labelled", "factor")
        , label = "Test me!"
      )
    )

    expect_identical(
      object = z
      , expected = structure(
        2L
        , .Label = letters[1:10]
        , class = c("tiny_labelled", "factor")
        , label = "Test me!"
      )
    )
    expect_identical(
      object = zz
      , expected = structure(
        2L
        , .Label = letters[1:10]
        , class = "factor"
      )
    )

    expect_identical(variable_label(y), "Test me!")
    expect_identical(class(y), c("tiny_labelled", "factor"))
    expect_identical(levels(y), letters[1:10])
  }
)



test_that(
  "rep.tiny_labelled-method"
  , {
    o1 <- 1:3
    variable_label(o1) <- "Test me!"
    o1 <- rep(o1, 2)
    o2 <- rep(1:3, 2)
    variable_label(o2) <- "Test me!"

    expect_identical(
      object = o1
      , expected = o2
    )
  }
)



test_that(
  "print.tiny_labelled-method"
  , {
    labelled_vector <- 1:4
    variable_label(labelled_vector) <- "Test label"
    print_with_label <- capture_output(print(labelled_vector))
    # + unit
    attr(labelled_vector, "unit") <- "cm"
    print_with_unit <- capture_output(print(labelled_vector))

    expect_identical(
      print_with_label
      , expected = "Variable label     : Test label\n[1] 1 2 3 4"
    )
    expect_identical(
      print_with_unit
      , expected = "Variable label     : Test label\nUnit of measurement: cm\n[1] 1 2 3 4"
    )
  }
)

test_that(
  "Coercion of tiny_labelled"
  , {
    labelled_vector <- 0:4
    variable_label(labelled_vector) <- "Test label"

    # as.logical() ----
    expect_identical(
      as.logical(labelled_vector)
      , structure(
        as.logical(0:4)
        , label = "Test label"
        , class = c("tiny_labelled", "logical")
      )
    )
    expect_identical(
      as.logical(labelled_vector, keep_label = FALSE)
      , as.logical(0:4)
    )

    # as.integer() ----
    expect_identical(
      as.integer(labelled_vector)
      , labelled_vector
    )
    expect_identical(
      as.integer(labelled_vector, keep_label = FALSE)
      , 0:4
    )

    # as.double() ----
    expect_identical(
      as.double(labelled_vector)
      , structure(
        as.double(0:4)
        , label = "Test label"
        , class = c("tiny_labelled", "numeric")
      )
    )
    expect_identical(
      as.double(labelled_vector, keep_label = FALSE)
      , as.double(0:4)
    )

    # as.numeric() ----
    expect_identical(
      as.numeric(labelled_vector)
      , as.double(labelled_vector)
    )
    expect_identical(
      as.numeric(labelled_vector, keep_label = FALSE)
      , as.double(labelled_vector, keep_label = FALSE)
    )

    # as.complex() ----
    expect_identical(
      as.complex(labelled_vector)
      , structure(
        as.complex(0:4)
        , label = "Test label"
        , class = c("tiny_labelled", "complex")
      )
    )
    expect_identical(
      as.complex(labelled_vector, keep_label = FALSE)
      , as.complex(0:4)
    )


    # as.character() ----
    expect_identical(
      as.character(labelled_vector)
      , structure(
        as.character(0:4)
        , label = "Test label"
        , class = c("tiny_labelled", "character")
      )
    )
    expect_identical(
      as.character(labelled_vector, keep_label = FALSE)
      , as.character(0:4)
    )
  }
)

test_that(
  "Arithmetic group generics"
  , {
    labelled_vector <- -1:4
    variable_label(labelled_vector) <- "An integer vector"

    # Math (x, ...)
    expect_identical(
      abs(labelled_vector)
      , expected = abs(-1:4)
    )
    # Ops (e1, e2)
    expect_identical(
      labelled_vector/2
      , expected = -1:4 / 2 # numeric!
    )
    # Ops (e1)
    expect_identical(
      -labelled_vector
      , expected = 1:-4
    )
    # Summary(..., na.rm = FALSE)
    expect_identical(
      min(labelled_vector)
      , -1L
    )
    # Complex(z)
    labelled_complex <- as.complex(1:4)
    variable_label(labelled_complex) <- "A complex-valued vector"
    expect_identical(
      Im(labelled_complex)
      , expected = rep(0, 4)
    )

  }
)

context("methods for generics from stats")

test_that(
  "relevel.tiny_labelled-method"
  , {
    o1 <- factor(letters[1:3], levels = letters[1:3])
    variable_label(o1) <- "Test me!"
    o1 <- relevel(o1, "b")

    expect_identical(
      object = o1
      , expected = structure(c(2L, 1L, 3L), .Label = c("b", "a", "c"), class = c("tiny_labelled", "factor"), label = "Test me!")
    )
    # Check all attributes separately, as sometimes expect_identical seems to be sloppy
    expect_identical(variable_label(o1), expected = "Test me!")
    expect_identical(levels(o1), expected = c("b", "a", "c"))
    expect_identical(class(o1), expected = c("tiny_labelled", "factor"))
  }
)

test_that(
  "Test difftime objects"
  , {
    t0 <- as.difftime(tim = 60, units = "secs")
    variable_label(t0) <- "Computation time"

    captured <- capture_output(print(t0))

    expect_identical(
      captured
      , "Variable label     : Computation time\nUnit of measurement: secs\nTime difference of 60 secs"
    )
  }
)

context("variable_label() replacement methods")

test_that(
  "variable_label<-.default"
  , {
    object <- 1:4
    variable_label(object) <- "Label 1"

    expect_identical(
      object = object
      , expected = structure(
        1:4
        , label = "Label 1"
        , class = c("tiny_labelled", "integer")
      )
    )

    expect_error(
      variable_label(object) <- NULL
      , regexp = "Variable labels must not be NULL. To entirely remove variable labels, use unlabel()."
    )
    expect_error(
      variable_label(object) <- 1:2
      , regexp = "Trying to set a variable label of length greater than one: '1', '2'"
    )

    # Recursively use unlist() on list-like input
    variable_label(object) <- list(b = list("a"))
    expect_identical(
      variable_label(object)
      , "a"
    )
  }
)

test_that(
  "variable_label<-.data.frame"
  , {
    object <- data.frame(a = 1:4, b = 5:8)
    object$c <- list(1:2, 3:4, 5:6, 7:8) # add a list column

    expect_error(
      variable_label(object) <- c("not_in_data" = "test")
      , "While trying to set variable labels, some requested columns could not be found in data.frame:\n'not_in_data'"
      , fixed = TRUE
    )
    expect_error(
      variable_label(object) <- "a"
      , "The assigned variable label(s) must be passed as a named vector or a named list."
      , fixed = TRUE
    )
    variable_label(object) <- c("a" = "A beautiful test label.", c = "Deal with list columns")

    expect_identical(
      object = object
      , expected = structure(
        list(
          a = structure(
            1:4
            , label = "A beautiful test label."
            , class = c("tiny_labelled", "integer")
          )
          , b = 5:8
          , c = structure(
            list(1:2, 3:4, 5:6, 7:8)
            , label = "Deal with list columns"
            , class = c("tiny_labelled", "list")
          )
        )
        , row.names = c(NA, -4L)
        , class = "data.frame"
      )
    )

    object <- label_variables(
      object
      , a = "A different, but equally beautiful, test label."
      , b = "A mediocre reinterpretation of the a's label."
    )

    expect_identical(
      object = object
      , expected = structure(
        list(
          a = structure(
            1:4
            , label = "A different, but equally beautiful, test label."
            , class = c("tiny_labelled", "integer")
          )
          , b = structure(
            5:8
            , label = "A mediocre reinterpretation of the a's label."
            , class = c("tiny_labelled", "integer")
          )
          , c = structure(
            list(1:2, 3:4, 5:6, 7:8)
            , label = "Deal with list columns"
            , class = c("tiny_labelled", "list")
          )
        )
        , row.names = c(NA, -4L)
        , class = "data.frame"
      )
    )

    object <- npk
    variable_label(object) <- c(
      N = "Nitrogen"
      , P = NULL
    )
  }
)

test_that(
  "variable_label.data.frame() for duplicate column names"
  , {
    object <- data.frame(x = 1, x = 2, check.names = F)
    variable_label(object) <- c(x = "Test duplicate columns")
    expect_identical(
      variable_label(object)
      , list(x = "Test duplicate columns", x = "Test duplicate columns")
    )
  }
)

test_that(
  "variable_label.data.frame() -- only modify columns if value is not NULL"
  , {
    object <- data.frame(
      x = 1
      , y = 2
    )
    variable_labels(object) <- list(
      x = "A nice label"
      , y = NULL
    )

    expect_identical(
      variable_labels(object)
      , list(x = "A nice label", y = NULL)
    )

  }
)



context("variable_label() extraction methods")

test_that(
  "variable_label.tiny_labelled-method"
  , {
    object <- 1:10
    class(object) <- c("tiny_labelled", "integer")
    attr(object, "label") <- "label1"

    expect_identical(
      object = variable_label(object)
      , expected = "label1"
    )
  }
)

test_that(
  "variable_label.data.frame-method"
  , {
    x <- npk
    variable_label(x) <- list(N = "Nitrogen", P = "Phosphate", K = expression(italic(K)))

    expect_identical(
      variable_label(x)
      , list(
        block   = NULL
        , N     = "Nitrogen"
        , P     = "Phosphate"
        , K     = expression(italic(K))
        , yield = NULL
      )
    )
    expect_error(
      variable_label(x) <- list(N = "a", N = "b")
      , "Duplicated names for 'value'."
      , fixed = TRUE
    )
  }
)

context("unlabel()")

test_that(
  "unlabel.default()"
  , {
    x <- letters
    variable_label(x) <- "Label to be removed"

    expect_identical(
      unlabel(x)
      , letters
    )
  }
)

test_that(
  "unlabel.data.frame()"
  , {
    x <- npk
    variable_label(x) <- list(N = "Nitrogen", yield = "Yield", P = expression(italic(P)))

    expect_identical(
      unlabel(x)
      , npk
    )
  }
)
